import java.util.ArrayList;

/**
 *
 * @author gsimon
 * Classe permettant de gérer les déplacement d'une tour
 * A COMPLETER !
 */
public class Tour extends Piece {


    public Tour(String coul) {
        super(coul);
    }

    @Override
    public ArrayList<Case> getDepPossibles(Echiquier ech) {

        //tenir compte des couleurs des pieces
        //une boucle par déplacement
        //verif case existe
        //si vide -> case dispo
        // si non
        //      -> la piece est de la meme couleur -> case impossible
        //      -> couleur opposé -> case dispo

        ArrayList<Case> depPossible = new ArrayList<>();
        int caseBas = this.getL()+1;
        int caseHaut = this.getL()-1;
        int caseDroite = this.getC()+1;
        int caseGauche = this.getC()-1;
        Case caseLibre ;
        int i ;

        /* BAS*/
        while(ech.caseExiste(caseBas, this.getC()) ){
            if( ech.getPiece(caseBas,this.getC()) == null  ){
                caseLibre = new Case(caseBas,this.getC());
                depPossible.add(caseLibre);
                caseBas ++;
            }else {
                if (ech.getPiece(caseBas,this.getC()).getCoul() == this.getCoul()){
                    break;
                } else {
                    caseLibre = new Case(caseBas,this.getC());
                    depPossible.add(caseLibre);
                    break;
                }

            }

        }

        /*DROITE*/
        while(ech.caseExiste(this.getL(), caseDroite) ){
            if( ech.getPiece(this.getL(),caseDroite) == null  ){
                caseLibre = new Case(this.getL(),caseDroite);
                depPossible.add(caseLibre);
                caseDroite ++;
            }else {
                if (ech.getPiece(this.getL(),caseDroite).getCoul() == this.getCoul()){
                    break;
                } else {
                    caseLibre = new Case(this.getL(),caseDroite);
                    depPossible.add(caseLibre);
                    break;
                }

            }

        }

        /* HAUT */

        while(ech.caseExiste(caseHaut, this.getC()) ){
            if( ech.getPiece(caseHaut,this.getC()) == null  ){
                caseLibre = new Case(caseHaut,this.getC());
                depPossible.add(caseLibre);
                caseHaut --;
            }else {
                if (ech.getPiece(caseHaut,this.getC()).getCoul() == this.getCoul()){
                    break;
                } else {
                    caseLibre = new Case(caseHaut,this.getC());
                    depPossible.add(caseLibre);
                    break;
                }

            }

        }

        /*GAUCHE*/
        while(ech.caseExiste(this.getL(), caseGauche) ){
            if( ech.getPiece(this.getL(),caseGauche) == null  ){
                caseLibre = new Case(this.getL(),caseGauche);
                depPossible.add(caseLibre);
                caseGauche --;
            }else {
                if (ech.getPiece(this.getL(),caseGauche).getCoul() == this.getCoul()){
                    break;
                } else {
                    caseLibre = new Case(this.getL(),caseGauche);
                    depPossible.add(caseLibre);
                    break;
                }

            }

        }







        return depPossible;
    }

    @Override
    public String toString() {
        String nom = null;
        if (getCoul() == BLANC){
            nom = "TB";
        }else {
            nom = "TN";
        }
        return nom;
    }
}
